Index: trunk/src/org/expeditee/assets/resources-public/framesets/authentication/4.exp
===================================================================
--- trunk/src/org/expeditee/assets/resources-public/framesets/authentication/4.exp	(revision 1414)
+++ trunk/src/org/expeditee/assets/resources-public/framesets/authentication/4.exp	(revision 1415)
@@ -1,8 +1,8 @@
-V 228
-p 40
+V 232
+p 400
 U authadmin
 D 07Jan2019[14:34]
 M nobody
-d 30May2019[12:55]
+d 04Jul2019[13:23]
 B 100 100 39 100
 Z
@@ -20,5 +20,5 @@
 m 0.0
 h -1.0
-p 40
+p 400
 _sl F
 
@@ -35,5 +35,5 @@
 m 0.0
 h -1.0
-p 40
+p 400
 _sl F
 
@@ -50,5 +50,5 @@
 m 0.0
 h -1.0
-p 40
+p 400
 _sl F
 
@@ -65,5 +65,5 @@
 m 0.0
 h -1.0
-p 40
+p 400
 _sl F
 
@@ -85,5 +85,5 @@
 M 300
 h 1.0
-p 44
+p 444
 _ph Username
 _sl F
@@ -110,6 +110,8 @@
 M 300
 h 1.0
-p 41
+p 411
+_sl F
 _ti 2
+_ae true
 
 S P 328
@@ -148,6 +150,7 @@
 M 300
 h 1.0
-p 44
+p 444
 _ph Identity Number
+_sl F
 _ti 3
 
@@ -172,6 +175,8 @@
 M 300
 h 1.0
-p 41
+p 411
+_sl F
 _ti 4
+_ae true
 
 S P 382
@@ -217,6 +222,7 @@
 M 300
 h 1.0
-p 44
+p 444
 _ph Password Piece Two
+_sl F
 _ti 6
 
@@ -239,6 +245,7 @@
 M 300
 h 1.0
-p 44
+p 444
 _ph Password Piece One
+_sl F
 _ti 5
 
@@ -262,5 +269,5 @@
 M 300
 h 1.0
-p 44
+p 444
 _ph New Password Again
 _sl F
@@ -286,5 +293,5 @@
 M 300
 h 1.0
-p 44
+p 444
 _ph New Password
 _sl F
@@ -310,7 +317,8 @@
 M 205
 h 1.0
-p 41
+p 411
 _sl F
 _ti 9
+_ae true
 
 S P 618
@@ -325,5 +333,5 @@
 l 620 639
 c 1313 1314
-p 41
+p 411
 
 S P 619
@@ -337,5 +345,5 @@
 l 620 621
 c 1313 1315
-p 41
+p 411
 
 S P 622
@@ -349,5 +357,5 @@
 l 624 625
 c 1373 1374
-p 41
+p 411
 
 S P 623
@@ -361,5 +369,5 @@
 l 625 635
 c 1373 1376
-p 41
+p 411
 
 S T 626
@@ -377,5 +385,5 @@
 m 0.0
 h -1.0
-p 41
+p 411
 _sl F
 
@@ -394,5 +402,5 @@
 m 0.0
 h -1.0
-p 41
+p 411
 _sl F
 
@@ -411,5 +419,5 @@
 m 0.0
 h -1.0
-p 41
+p 411
 _sl F
 
@@ -428,5 +436,5 @@
 m 0.0
 h -1.0
-p 41
+p 411
 _sl F
 
@@ -445,5 +453,5 @@
 m 0.0
 h -1.0
-p 41
+p 411
 _sl F
 
@@ -462,5 +470,5 @@
 m 0.0
 h -1.0
-p 41
+p 411
 _sl F
 
@@ -479,5 +487,5 @@
 m 0.0
 h -1.0
-p 41
+p 411
 _sl F
 
@@ -493,5 +501,5 @@
 l 624 636
 c 1374 1375
-p 41
+p 411
 
 S P 634
@@ -505,5 +513,5 @@
 l 635 636
 c 1376 1375
-p 41
+p 411
 
 S P 637
@@ -517,5 +525,5 @@
 l 621 640
 c 1315 1320
-p 41
+p 411
 
 S P 638
@@ -529,5 +537,5 @@
 l 639 640
 c 1314 1320
-p 41
+p 411
 
 Z
@@ -591,127 +599,40 @@
 Z
 
-ActiveTime:01:37:49
+ActiveTime:01:38:25
 DarkTime:02:33:57
-55:59:214 974 141 kSHIFT
-55:59:413 974 141 kT
-55:59:669 985 141 kO
-55:59:820 994 141 kG
-55:59:955 1003 141 kG
-56:00:066 1012 141 kL
-56:00:186 1016 141 kE
-56:00:348 1025 141 kSHIFT
-56:00:436 1025 141 kA
-56:00:660 1038 141 kU
-56:00:763 1047 141 kT
-56:00:863 1052 141 kH
-56:01:085 1061 141 kCTRL
-56:01:245 1061 141 kA
-56:12:623 644 193 Ld
-56:12:691 644 193 Rd
-56:12:826 644 193 Lu
-56:12:843 644 193 Ru
-56:13:979 986 135 Ld
-56:14:115 986 135 Lu
-56:14:966 696 197 Ld
-56:15:012 696 197 Rd
-56:15:147 696 197 Lu
-56:15:187 696 197 Ru
-56:26:280 1069 243 Md
-56:26:299 1069 243 Rd
-56:26:419 1069 243 Mu
-56:26:426 1069 243 Ru
-56:27:534 1026 139 Md
-56:27:571 1026 139 Rd
-56:27:779 1026 139 Ru
-56:27:780 1026 139 Mu
-56:31:507 663 197 Ld
-56:31:581 663 197 Rd
-56:31:723 663 197 Lu
-56:31:747 663 197 Ru
-56:34:254 1038 189 Md
-56:34:314 1038 189 Rd
-56:34:523 1038 189 Mu
-56:34:538 1038 189 Ru
-56:35:068 1151 300 kSHIFT
-56:35:568 1150 300 kSHIFT
-56:35:599 1150 300 kSHIFT
-56:35:632 1150 300 kSHIFT
-56:35:666 1150 300 kSHIFT
-56:35:699 1150 300 kSHIFT
-56:35:732 1150 300 kSHIFT
-56:35:764 1150 300 kSHIFT
-56:35:798 1150 300 kSHIFT
-56:35:831 1150 300 kSHIFT
-56:35:863 1150 300 kSHIFT
-56:35:874 1150 300 kW
-56:36:380 1167 300 kI
-56:36:451 1172 300 kD
-56:36:645 1181 300 kT
-56:36:707 1186 300 kH
-56:36:810 1195 300 kSHIFT
-56:38:190 1182 295 Md
-56:38:307 1182 295 Mu
-56:38:894 625 191 Rd
-56:38:987 625 191 Ru
-56:39:764 627 249 Rd
-56:39:859 627 249 Ru
-56:41:702 1047 334 Md
-56:41:781 1047 334 Rd
-56:41:931 1047 334 Ru
-56:41:947 1047 334 Mu
-56:54:550 704 261 Ld
-56:54:765 704 261 Rd
-56:54:947 704 261 Ru
-56:54:955 704 261 Lu
-56:58:422 1052 309 Md
-56:58:451 1052 309 Rd
-56:58:627 1052 309 Ru
-56:58:627 1052 309 Mu
-57:09:933 848 208 kBACKSPACE
-57:20:206 1047 362 kSHIFT
-57:20:389 1047 362 kW
-57:20:678 1064 362 kSHIFT
-57:24:475 1085 362 Md
-57:24:619 1085 362 Mu
-57:25:366 720 212 Md
-57:25:459 720 212 Mu
-57:29:539 1023 282 kSHIFT
-57:29:997 1023 282 kW
-57:30:349 1040 282 kI
-57:30:428 1045 282 kD
-57:30:669 1054 282 kT
-57:30:748 1059 282 kH
-57:30:835 1068 282 kSHIFT
-57:33:967 1109 284 Md
-57:34:107 1109 284 Mu
-57:35:022 700 206 Rd
-57:35:131 700 206 Ru
-57:36:262 690 248 Rd
-57:36:363 690 248 Ru
-57:38:078 1136 307 Md
-57:38:203 1136 307 Mu
-57:39:158 660 256 Ld
-57:39:643 660 256 Lu
-57:42:876 881 215 kBACKSPACE
-57:43:086 874 219 kBACKSPACE
-57:43:396 865 219 kBACKSPACE
-57:45:393 600 212 kBACKSPACE
-57:45:589 590 219 kBACKSPACE
-57:45:819 582 219 kBACKSPACE
-57:49:485 1047 296 kSHIFT
-57:49:582 1047 296 kM
-57:49:806 1066 305 kI
-57:49:875 1071 305 kN
-57:51:391 1080 305 Md
-57:51:507 1080 305 Mu
-57:52:144 705 215 Rd
-57:52:195 705 215 Ru
-57:52:846 710 250 Rd
-57:52:931 710 250 Ru
-57:53:726 1142 372 Md
-57:53:788 1142 372 Rd
-57:53:923 1142 372 Ru
-57:53:947 1142 372 Mu
-58:00:035 1153 256 kCTRL
-58:00:538 1153 257 kCTRL
-58:00:554 1153 257 kS
+23:59:891 1076 133 kSHIFT
+24:00:098 1076 133 kT
+24:00:530 1087 133 kO
+24:00:739 1096 133 kG
+24:00:868 1105 133 kG
+24:00:971 1114 133 kL
+24:01:059 1119 133 kE
+24:01:203 1127 133 kSHIFT
+24:01:267 1127 133 kA
+24:01:452 1140 133 kU
+24:01:516 1149 133 kT
+24:01:661 1154 133 kH
+24:01:787 1163 133 kCTRL
+24:01:956 1163 133 kA
+24:02:797 1163 133 Ld
+24:02:891 1163 133 Lu
+24:03:467 747 207 Ld
+24:03:540 747 207 Rd
+24:03:643 747 207 Ru
+24:03:659 747 207 Lu
+24:04:533 1049 204 Md
+24:04:555 1049 204 Rd
+24:04:691 1049 204 Mu
+24:04:698 1049 204 Ru
+24:05:310 731 267 Ld
+24:05:362 731 267 Rd
+24:05:476 732 268 Lu
+24:05:477 732 268 Ru
+24:06:052 1306 239 Md
+24:06:076 1306 239 Rd
+24:06:220 1305 239 Mu
+24:06:236 1303 238 Ru
+24:06:662 1075 125 Md
+24:06:685 1075 125 Rd
+24:06:787 1075 125 Ru
+24:06:803 1075 125 Mu
Index: trunk/src/org/expeditee/assets/resources-public/framesets/authentication/5.exp
===================================================================
--- trunk/src/org/expeditee/assets/resources-public/framesets/authentication/5.exp	(revision 1414)
+++ trunk/src/org/expeditee/assets/resources-public/framesets/authentication/5.exp	(revision 1415)
@@ -1,8 +1,8 @@
-V 194
-p 40
+V 196
+p 400
 U authadmin
 D 07Jan2019[14:34]
 M authadmin
-d 23May2019[14:56]
+d 04Jul2019[13:23]
 B 100 100 39 100
 Z
@@ -20,4 +20,5 @@
 m 0.0
 h -1.0
+_sl F
 
 S T 373
@@ -33,4 +34,5 @@
 m 0.0
 h -1.0
+_sl F
 
 S T 374
@@ -46,4 +48,5 @@
 m 0.0
 h -1.0
+_sl F
 
 S T 392
@@ -59,4 +62,5 @@
 m 0.0
 h -1.0
+_sl F
 
 S T 410
@@ -77,6 +81,7 @@
 M 300
 h 1.0
-p 44
+p 444
 _ph Trusted User One
+_sl F
 _ti 1
 
@@ -103,4 +108,5 @@
 m 0.0
 h 2.0
+_sl F
 
 S T 406
@@ -121,6 +127,7 @@
 M 300
 h 1.0
-p 44
+p 444
 _ph Trusted User Two
+_sl F
 _ti 2
 
@@ -144,6 +151,8 @@
 M 300
 h 1.0
-p 41
+p 411
+_sl F
 _ti 3
+_ae true
 
 S P 428
@@ -183,4 +192,5 @@
 m 0.0
 h -1.0
+_sl F
 
 S T 426
@@ -198,4 +208,5 @@
 m 0.0
 h -1.0
+_sl F
 
 S T 427
@@ -213,4 +224,5 @@
 m 0.0
 h -1.0
+_sl F
 
 S P 429
@@ -267,88 +279,26 @@
 Z
 
-ActiveTime:01:16:40
+ActiveTime:01:17:19
 DarkTime:01:04:09
-55:35:445 516 401 Ld
-55:35:533 517 401 Rd
-55:35:661 517 401 Lu
-55:35:662 517 401 Ru
-55:36:574 756 335 Md
-55:36:749 756 335 Rd
-55:39:613 756 335 Ru
-55:39:765 756 335 Mu
-56:18:735 420 343 Ld
-56:18:821 420 343 Rd
-56:18:990 420 343 Lu
-56:19:005 420 343 Ru
-56:19:990 194 308 Md
-56:20:054 194 308 Rd
-56:20:205 194 308 Ru
-56:20:206 194 308 Mu
-56:20:789 712 452 kCTRL
-56:21:150 712 452 kV
-56:22:334 660 472 Md
-56:22:445 660 472 Mu
-56:23:326 650 468 kSHIFT
-56:23:454 650 468 kA
-56:23:702 673 472 kC
-56:24:022 681 472 kT
-56:24:221 686 472 kI
-56:24:278 691 472 kO
-56:24:334 700 472 kN
-56:24:446 709 472 kSHIFT
-56:26:078 705 489 Md
-56:26:182 705 489 Mu
-56:27:014 611 401 Md
-56:27:118 611 401 Mu
-56:28:070 579 411 Ld
-56:28:126 579 410 Rd
-56:28:246 581 410 Lu
-56:28:247 581 410 Ru
-56:29:670 177 348 Md
-56:29:750 177 348 Rd
-56:29:925 177 348 Ru
-56:29:941 177 348 Mu
-56:31:326 413 392 Ld
-56:31:374 413 392 Rd
-56:31:477 413 392 Lu
-56:31:485 413 392 Ru
-56:32:455 185 308 Md
-56:32:526 185 308 Rd
-56:32:670 185 308 Ru
-56:32:685 185 308 Mu
-56:35:846 235 568 kCTRL
-56:35:926 265 589 kV
-56:36:486 278 572 Md
-56:36:581 278 572 Mu
-56:37:558 271 565 kSHIFT
-56:37:686 271 565 kA
-56:37:878 291 572 kC
-56:38:190 299 572 kT
-56:38:437 304 572 kI
-56:38:501 309 572 kO
-56:38:565 318 572 kN
-56:38:741 327 572 kSHIFT
-56:41:150 376 560 Md
-56:41:254 376 560 Mu
-56:41:998 464 400 Md
-56:42:093 464 400 Mu
-56:42:966 493 401 Ld
-56:43:102 493 401 Rd
-56:43:214 493 401 Ru
-56:43:229 493 401 Lu
-56:44:518 73 380 Md
-56:44:606 73 380 Rd
-56:44:733 73 380 Ru
-56:44:749 73 380 Mu
-56:45:622 786 366 kCTRL
-56:46:054 786 366 kS
-56:47:478 489 407 Ld
-56:47:566 489 407 Rd
-56:47:678 489 407 Ru
-56:47:694 489 407 Lu
-56:48:542 213 321 Md
-56:48:598 213 321 Rd
-56:48:733 213 321 Ru
-56:48:742 213 321 Mu
-56:50:095 441 467 Ld
-56:50:174 441 467 Lu
+23:19:762 102 718 kSHIFT
+23:19:949 102 718 kE
+23:20:099 113 718 kN
+23:20:218 122 718 kT
+23:20:331 126 718 kE
+23:20:427 135 718 kR
+23:20:605 141 718 kSHIFT
+23:20:770 141 718 kC
+23:20:948 153 718 kL
+23:21:082 158 718 kI
+23:21:220 163 718 kC
+23:21:325 171 718 kK
+23:21:396 180 718 kSHIFT
+23:21:836 189 718 kT
+23:21:996 194 718 kR
+23:22:077 200 718 kU
+23:22:180 209 718 kE
+23:23:646 205 714 Md
+23:23:738 205 714 Mu
+23:24:548 434 402 Md
+23:24:634 434 402 Mu
+23:26:428 479 628 kRIGHT_ARROW
Index: trunk/src/org/expeditee/assets/resources-public/framesets/authentication/6.exp
===================================================================
--- trunk/src/org/expeditee/assets/resources-public/framesets/authentication/6.exp	(revision 1414)
+++ trunk/src/org/expeditee/assets/resources-public/framesets/authentication/6.exp	(revision 1415)
@@ -1,8 +1,8 @@
-V 835
-p 40
+V 837
+p 400
 U authadmin
 D 23Nov2018[12:31]
 M authadmin
-d 23May2019[14:31]
+d 04Jul2019[13:23]
 B 100 100 39 100
 Z
@@ -41,4 +41,5 @@
 m 0.0
 h -1.0
+_sl F
 
 S T 1684
@@ -53,4 +54,5 @@
 m 0.0
 h -1.0
+_sl F
 
 S T 1685
@@ -65,4 +67,5 @@
 m 0.0
 h -1.0
+_sl F
 
 S T 1686
@@ -77,4 +80,5 @@
 m 0.0
 h -1.0
+_sl F
 
 S P 1689
@@ -113,5 +117,6 @@
 m 0.0
 h -1.0
-p 40
+p 400
+_sl F
 
 S T 1673
@@ -128,5 +133,6 @@
 m 0.0
 h -1.0
-p 40
+p 400
+_sl F
 
 S T 1670
@@ -143,5 +149,6 @@
 m 0.0
 h -1.0
-p 40
+p 400
+_sl F
 
 S T 1637
@@ -158,5 +165,6 @@
 m 0.0
 h -1.0
-p 40
+p 400
+_sl F
 
 S T 1266
@@ -179,6 +187,7 @@
 M 300
 h 1.0
-p 44
+p 444
 _ph Username
+_sl F
 _ti 1
 
@@ -203,6 +212,7 @@
 M 300
 h 1.0
-p 44
+p 444
 _ph Password
+_sl F
 _ti 2
 
@@ -226,6 +236,8 @@
 M 205
 h 1.0
-p 41
+p 411
+_sl F
 _ti 3
+_ae true
 
 S P 1703
@@ -265,5 +277,6 @@
 m 0.0
 h -1.0
-p 41
+p 411
+_sl F
 
 S T 1696
@@ -281,5 +294,6 @@
 m 0.0
 h -1.0
-p 41
+p 411
+_sl F
 
 S T 1697
@@ -297,5 +311,6 @@
 m 0.0
 h -1.0
-p 41
+p 411
+_sl F
 
 S P 1704
@@ -359,5 +374,6 @@
 m 0.0
 h -1.0
-p 41
+p 411
+_sl F
 
 S T 1699
@@ -375,5 +391,6 @@
 m 0.0
 h -1.0
-p 41
+p 411
+_sl F
 
 S T 1700
@@ -391,5 +408,6 @@
 m 0.0
 h -1.0
-p 01
+p 011
+_sl F
 
 S T 1701
@@ -407,5 +425,6 @@
 m 0.0
 h -1.0
-p 41
+p 411
+_sl F
 
 S T 1702
@@ -423,5 +442,6 @@
 m 0.0
 h -1.0
-p 41
+p 411
+_sl F
 
 S P 1709
@@ -549,11 +569,34 @@
 Z
 
-ActiveTime:19857915:44:01
-DarkTime:-19847399:-39:-16
-32:20:162 706 445 Md
-32:20:290 706 445 Rd
-32:20:538 706 445 Ru
-32:20:594 706 445 Mu
-32:37:858 766 295 kCTRL
-32:38:635 766 295 kCTRL
-32:38:858 766 295 kS
+ActiveTime:19857915:44:18
+DarkTime:-19847087:-39:-16
+23:29:005 178 694 kSHIFT
+23:29:109 178 694 kE
+23:29:362 189 694 kN
+23:29:441 198 694 kT
+23:29:506 203 694 kE
+23:29:580 211 694 kR
+23:29:763 217 694 kSHIFT
+23:29:906 217 694 kC
+23:30:140 228 694 kL
+23:30:299 234 694 kI
+23:30:403 239 694 kC
+23:30:516 247 694 kK
+23:30:603 256 694 kSHIFT
+23:31:476 265 694 kT
+23:31:652 270 694 kR
+23:31:732 276 694 kU
+23:31:811 285 694 kE
+23:32:950 293 694 Md
+23:33:066 293 694 Mu
+23:33:738 432 403 Md
+23:33:850 432 403 Mu
+23:36:710 481 410 Ld
+23:36:773 481 410 Rd
+23:36:931 481 410 Lu
+23:36:931 481 410 Ru
+23:37:750 338 458 Md
+23:37:836 338 458 Rd
+23:38:002 338 458 Ru
+23:38:042 338 458 Mu
+23:39:396 175 714 kRIGHT_ARROW
Index: trunk/src/org/expeditee/core/bounds/CombinationBounds.java
===================================================================
--- trunk/src/org/expeditee/core/bounds/CombinationBounds.java	(revision 1414)
+++ trunk/src/org/expeditee/core/bounds/CombinationBounds.java	(revision 1415)
@@ -87,7 +87,7 @@
 
 	@Override
-	public int getMaxX() 
-	{
-		int maxX = Integer.MIN_VALUE;
+	public int getMaxX() {
+		// +1 makes it safe to do math.abs on
+		int maxX = Integer.MIN_VALUE + 1;
 		
 		for (Bounds b : _bounds) {
@@ -113,7 +113,7 @@
 
 	@Override
-	public int getMaxY()
-	{
-		int maxY = Integer.MIN_VALUE;
+	public int getMaxY() {
+		// +1 makes it safe to do math.abs on
+		int maxY = Integer.MIN_VALUE + 1;
 		
 		for (Bounds b : _bounds) {
Index: trunk/src/org/expeditee/core/bounds/EllipticalBounds.java
===================================================================
--- trunk/src/org/expeditee/core/bounds/EllipticalBounds.java	(revision 1414)
+++ trunk/src/org/expeditee/core/bounds/EllipticalBounds.java	(revision 1415)
@@ -70,17 +70,14 @@
 	
 	@Override
-	public boolean contains(int x, int y)
-	{
+	public boolean contains(int x, int y) {
 		// If the ellipse is degenerate then it can't contain anything
 		if (_diameters.getArea() == 0) return false;
-		
-		// Get the position of the given coordinates with respect to the ellipse centre 
-		Point pRel = new Point(x - _centre.getX(), y - _centre.getY());
-		
-		// x^2 / r_x^2 + y^2 / r_y^2 must be <= 1
-		// (using diameters instead of radii hence the 4.0f value)
-		float xNorm = (((float) pRel.getX()) * pRel.getX()) / (((float) _diameters.width) * _diameters.width);
-		float yNorm = (((float) pRel.getY()) * pRel.getY()) / (((float) _diameters.height) * _diameters.height);
-		return (xNorm + yNorm <= 4.0f);
+
+		double deltaXSq = Math.pow(x - _centre.getX(), 2);
+		double deltaYSq = Math.pow(y - _centre.getY(), 2);
+		double minorAxisSq = Math.pow(Math.min(_diameters.height, _diameters.width) / 2, 2);
+		double majorAxisSq = Math.pow(Math.max(_diameters.height, _diameters.width) / 2, 2);
+		double result = (deltaXSq / majorAxisSq) + (deltaYSq / minorAxisSq);
+		return result <= 1.0f;
 	}
 	
@@ -118,6 +115,5 @@
 	
 	@Override
-	public boolean equals(Bounds other)
-	{
+	public boolean equals(Bounds other) {
 		if (other instanceof EllipticalBounds) {
 			EllipticalBounds e = (EllipticalBounds) other;
@@ -128,6 +124,5 @@
 
 	@Override
-	public boolean intersects(AxisAlignedBoxBounds other)
-	{
+	public boolean intersects(AxisAlignedBoxBounds other) {
 		// Treat the box as a polygon
 		return intersects(other.getPolygon());
@@ -135,6 +130,5 @@
 
 	@Override
-	public boolean intersects(CombinationBounds other)
-	{
+	public boolean intersects(CombinationBounds other) {
 		// Defer to the CombinationBounds routine
 		return other.intersects(this);
@@ -142,6 +136,5 @@
 
 	@Override
-	public boolean intersects(EllipticalBounds other)
-	{
+	public boolean intersects(EllipticalBounds other) {
 		// TODO: Implement. cts16
 		System.err.println("Unimplemented method: EllipticalBounds.intersects(EllipticalBounds)");
Index: trunk/src/org/expeditee/core/bounds/PolygonBounds.java
===================================================================
--- trunk/src/org/expeditee/core/bounds/PolygonBounds.java	(revision 1414)
+++ trunk/src/org/expeditee/core/bounds/PolygonBounds.java	(revision 1415)
@@ -538,4 +538,13 @@
 		}
 	}
+	
+	public String toString() {
+		StringBuilder sb = new StringBuilder("PolygonBounds with: ");
+		sb.append("[MinX: " + getMinX() + "]");
+		sb.append("[MinY: " + getMinY() + "]");
+		sb.append("[MaxX: " + getMaxX() + "]");
+		sb.append("[MaxY: " + getMaxY() + "]");
+		return sb.toString();
+	}
 
 }
Index: trunk/src/org/expeditee/encryption/io/EncryptedExpReader.java
===================================================================
--- trunk/src/org/expeditee/encryption/io/EncryptedExpReader.java	(revision 1414)
+++ trunk/src/org/expeditee/encryption/io/EncryptedExpReader.java	(revision 1415)
@@ -24,4 +24,5 @@
 import javax.crypto.spec.SecretKeySpec;
 
+import org.expeditee.core.Point;
 import org.expeditee.encryption.CryptographyConstants;
 import org.expeditee.encryption.items.surrogates.EncryptionDetail;
@@ -33,4 +34,5 @@
 import org.expeditee.io.DefaultFrameWriter;
 import org.expeditee.io.ExpReader;
+import org.expeditee.items.Constraint;
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
@@ -44,9 +46,12 @@
 	private SecretKey personalKey;
 	private boolean accessDenied = false;
+	private boolean _readingSurrogates;
+	private static final Predicate<String> endOfSection = s -> s.equals(EncryptedExpWriter.TERMINATOR + "") || s.equals(EncryptedExpWriter.TERMINATOR_WITH_CONTINUATION);
 
 	public static boolean isEncryptedExpediteeFile(final String path) throws IOException {
-		final BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(path), "UTF-8"));
-		final String firstLine = in.readLine();
+		BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(path), "UTF-8"));
+		String firstLine = in.readLine();
 		in.close();
+		if (firstLine == null) return false;
 		return firstLine.startsWith(ENCRYPTED_EXP_FLAG);
 	}
@@ -87,4 +92,5 @@
 		if (accessDenied) { return null; }
 		
+		_readingSurrogates = false;
 		_reader = reader;
 		String next = "";
@@ -106,4 +112,11 @@
 			next = readTheConstraints();
 			
+			if (next.equals(EncryptedExpWriter.TERMINATOR_WITH_CONTINUATION)) {
+				// Read the surrogates
+				_readingSurrogates = true;
+				next = readTheItems(newFrame, delayedActions);
+				_readingSurrogates = false;
+			}
+			
 			for(DelayedAction action: delayedActions) {
 				action.exec();
@@ -124,54 +137,37 @@
 	}
 	
-//	@Override
-//	protected String readTheItems(Frame newFrame, List<DelayedAction> delayedActions) throws IOException {
-//		String next = null;
-//		Item currentItem = null;
-//		
-//		Predicate<String> endOfSection = s -> s.equals(EncryptedExpWriter.TERMINATOR + "") || s.equals(EncryptedExpWriter.TERMINATOR_WITH_CONTINUATION);
-//		while (_reader.ready() && !endOfSection.test(next = _reader.readLine())) {
-//			if (!isValidLine(next)) {
-//				continue;
-//			}
-//			
-//			String tag = getTagEnc(next);
-//			if (next.startsWith(DefaultFrameWriter.TYPE_AND_ID_STR + " ")) {
-//				currentItem = newItem(next);
-//				_linePoints.put(currentItem.getID(), currentItem);
-//				newFrame.addItem(currentItem);
-//				currentItem.setEncryptionDetailForTag(tag + "", EncryptionDetail.UnencryptedOnSave);
-//			} else if (next.startsWith("SurrogateFor")) {
-//				int parentID = Integer.parseInt(next.split(" ")[1]);
-//				newFrame.getItemWithID(parentID).addToSurrogates(currentItem);
-//				newFrame.addToSurrogates(currentItem);
-//			} else if (currentItem != null && actionShouldBeDelayed(tag.charAt(0))) { 
-//				delayedActions.add(new DelayedAction(currentItem, next));
-//			} else if (currentItem != null) {
-//				processBodyLine(currentItem, next);
-//			} else {
-//				System.err.println("Error while reading in frame (ExpReader): Found body line but no current item to apply it to.");
-//			}
-//		}
-//				
-//		if (next.equals(EncryptedExpWriter.TERMINATOR_WITH_CONTINUATION)) {
-//			next = readTheItems(newFrame, delayedActions);
-//		}
-//		
-//		return next;
-//	}
-	
 	protected String readTheItems(Frame newFrame, List<DelayedAction> delayedActions) throws IOException {
-		// Read the primary item.
-		BiConsumer<Item, String> addToBody = (item, line) -> newFrame.addItem(item);
-		String next = readLineAfterLine(false, addToBody, delayedActions);
-		
-		// Read the surrogate items.
-		if (next.equals(EncryptedExpWriter.TERMINATOR_WITH_CONTINUATION)) {
-			BiConsumer<Item, String> addToSurrogates = (item, line) -> {
-				int parentID = Integer.parseInt(line.split(" ")[1]);
-				newFrame.getItemWithID(parentID).addToSurrogates(item);
-				newFrame.addToSurrogates(item);
-			};
-			next = readLineAfterLine(true, addToSurrogates, delayedActions);
+		BiConsumer<Item, String> primaryAdd = (item, line) -> newFrame.addItem(item);
+		BiConsumer<Item, String> surrogateAdd = (item, line) -> {
+			int parentID = Integer.parseInt(line.split(" ")[1]);
+			Item parent = newFrame.getItemWithID(parentID);
+			newFrame.addToSurrogatesOnLoad(item, parent);
+		};
+		
+		if (_readingSurrogates) {
+			return readLineAfterLine(true, surrogateAdd, delayedActions);
+		} else {
+			return readLineAfterLine(false, primaryAdd, delayedActions);
+		}
+	}
+	
+	@Override
+	protected String readTheConstraints() throws IOException, Exception {
+		String next = null;
+		while (_reader.ready() && !endOfSection.test(next = _reader.readLine())) {
+			if (isValidLine(next)) {
+				Point idtype = separateValues(next.substring(2));
+				// The next line must be the endpoints
+				if (!_reader.ready()) {
+					throw new Exception("Unexpected end of file");
+				}
+				next = _reader.readLine();
+				Point startend = separateValues(next.substring(2));
+
+				Item a = _linePoints.get(startend.getX());
+				Item b = _linePoints.get(startend.getY());
+
+				new Constraint(a, b, idtype.getX(), idtype.getY());
+			}
 		}
 		return next;
@@ -182,5 +178,4 @@
 		Item currentItem = null;
 		
-		Predicate<String> endOfSection = s -> s.equals(EncryptedExpWriter.TERMINATOR + "") || s.equals(EncryptedExpWriter.TERMINATOR_WITH_CONTINUATION);
 		while (_reader.ready() && !endOfSection.test(next = _reader.readLine())) {
 			if (!isValidLine(next)) {
@@ -195,5 +190,6 @@
 					storeResult.accept(currentItem, next);
 				}
-				currentItem.setEncryptionDetailForTag(tag + "", EncryptionDetail.UnencryptedOnSave);
+				EncryptionDetail unencryptedOnSave = new EncryptionDetail(EncryptionDetail.Type.UnencryptedOnSave);
+				currentItem.setEncryptionDetailForTag(tag + "", unencryptedOnSave);
 			} else if (next.startsWith("SurrogateFor")) {
 				if (isSurrogate) {
@@ -212,32 +208,4 @@
 	}
  	
-//	private String readLineAfterLine(Consumer<Item> storeResult, List<DelayedAction> delayedActions) throws IOException {
-//		String next = null;
-//		Item currentItem = null;
-//		
-//		Predicate<String> endOfSection = s -> {
-//			return s.equals(EncryptedExpWriter.TERMINATOR + "") || s.equals(EncryptedExpWriter.TERMINATOR_WITH_CONTINUATION);
-//		};
-//		while (_reader.ready() && !endOfSection.test(next = _reader.readLine())) {
-//			if (!isValidLine(next)) {
-//				continue;
-//			}
-//			
-//			String tag = getTagEnc(next);
-//			if (next.startsWith(DefaultFrameWriter.TYPE_AND_ID_STR + " ")) {
-//				currentItem = newItem(next);
-//				_linePoints.put(currentItem.getID(), currentItem);
-//				currentItem.setEncryptionDetailForTag(tag + "", EncryptionDetail.UnencryptedOnSave);
-//				storeResult.accept(currentItem);
-//			} else if (next.startsWith("SurrogateFor")) {
-//				int parentID = Integer.parseInt(next.split(" ")[1]);
-//				newFrame.getItemWithID(parentID).addToSurrogates(currentItem);
-//				new Delayed
-//			}
-//		}
-//		
-//		return next;
-//	}
-	
 	@Override
 	protected void processBodyLine(Item item, String line) {
@@ -245,24 +213,32 @@
 		String tag = getTagEnc(line);
 		String value = getValue(line);
-		
-		if (item.isSurrogate() && item.isTagInherited(tag)) {
+		boolean isEncryptedLine = isEncryptedLine(line);
+		
+		if (item.isSurrogate() && isEncryptedLine) {
+			// Surrogates should never have encrypted body lines.
 			return;
 		}
 		
 		// Attempt to decrypt the line if necessary.
-		if (isEncryptedLine(line)) {
-			LabelResult res = Label.resolveKey(item.getEncryptionLabel());
+		if (isEncryptedLine) {
+			LabelResult res = Label.getLabel(item.getEncryptionLabel());
 			if (res == LabelResult.SuccessResolveLabelToKey) {
-				item.setEncryptionDetailForTag(tag, EncryptionDetail.ReencryptOnSave);
+				EncryptionDetail reencryptOnSave = new EncryptionDetail(EncryptionDetail.Type.ReencryptOnSave);
+				item.setEncryptionDetailForTag(tag, reencryptOnSave);
 				SecretKey key = new SecretKeySpec(res.key, SymmetricAlgorithm);
 				byte[] decryptedBytes = DecryptSymmetric(Base64.getDecoder().decode(value), key);
 				value = new String(decryptedBytes);				
 			} else {
-				EncryptionDetail encryptionDetail = EncryptionDetail.UseUndecipheredValueOnSave.setUndecipheredValue(getValue(line));
-				item.setEncryptionDetailForTag(tag, encryptionDetail);
+				EncryptionDetail undecipheredValueOnSave = new EncryptionDetail(EncryptionDetail.Type.UseUndecipheredValueOnSave);
+				undecipheredValueOnSave.setUndecipheredValue(getValue(line));
+				item.setEncryptionDetailForTag(tag, undecipheredValueOnSave);
 				return;
 			}
 		} else {
-			item.setEncryptionDetailForTag(tag, EncryptionDetail.UnencryptedOnSave);
+			EncryptionDetail unencryptedOnSave = new EncryptionDetail(EncryptionDetail.Type.UnencryptedOnSave);
+			item.setEncryptionDetailForTag(tag, unencryptedOnSave);
+			if (item.isSurrogate()) {
+				item.setTagNotInherited(tag);
+			}
 		}
 		
@@ -394,5 +370,5 @@
 		
 		private SecretKeySpec resolveLabel(String label) {
-			LabelResult res = Label.resolveKey(label);
+			LabelResult res = Label.getLabel(label);
 			if (res == LabelResult.SuccessResolveLabelToKey) {
 				byte[] keyBytes = res.key;
Index: trunk/src/org/expeditee/encryption/io/EncryptedExpWriter.java
===================================================================
--- trunk/src/org/expeditee/encryption/io/EncryptedExpWriter.java	(revision 1414)
+++ trunk/src/org/expeditee/encryption/io/EncryptedExpWriter.java	(revision 1415)
@@ -23,7 +23,9 @@
 import org.expeditee.encryption.CryptographyConstants;
 import org.expeditee.encryption.items.surrogates.EncryptionDetail;
+import org.expeditee.encryption.items.surrogates.EncryptionDetail.Type;
 import org.expeditee.encryption.items.surrogates.Label;
 import org.expeditee.encryption.items.surrogates.Label.LabelResult;
 import org.expeditee.gui.Frame;
+import org.expeditee.gui.Frame.BodyType;
 import org.expeditee.gui.MessageBay;
 import org.expeditee.io.Conversion;
@@ -62,5 +64,5 @@
 			}
 		} else {
-			LabelResult res = Label.resolveKey(label);
+			LabelResult res = Label.getLabel(label);
 			if (res == LabelResult.SuccessResolveLabelToKey) {
 				byte[] keyBytes = res.key;
@@ -94,13 +96,20 @@
 		
 		// write item
-		writeItemData(frame);
+		writeItemData(frame, true);
 		writeTerminator();
-		
 		// write lines and constraints
 		writeLineData();
 		writeTerminator();
 		writeConstraintData();
-		writeTerminator();
-		
+		
+		// write surrogate items
+		if (frame.hasSurrogates()) {
+			writeSurrogateTerminator();
+			writeItemData(frame, false);
+			writeTerminator();
+		} else {
+			writeTerminator();
+		}
+				
 		writeLine(SessionStats.getFrameEventList(frame));
 	}
@@ -126,4 +135,10 @@
 	
 	protected void writeClass(Item toWrite) throws IOException {
+		if (toWrite instanceof Text && toWrite.getText().equals("Content for Label Two")) {
+			System.err.println("EncryptedExpWriter::writeClass::breakpoint");
+		} else if (toWrite instanceof Text && toWrite.getText().equals("Encrypted") && toWrite.getPrimary().getText().equals("Content for Label One")) {
+			System.err.println("EncryptedExpWriter::writeClass::breakpoint");
+		}
+		
 		LinkedHashMap<Character,Method> itemTags = new LinkedHashMap<Character, Method>(getItemTags());
 		LinkedHashMap<String,Method> itemTagsExt = new LinkedHashMap<String, Method>(getItemTagsExt());
@@ -149,6 +164,7 @@
 		}
 		EncryptionDetail encryptionDetail = toWrite.getEncryptionDetailForTag(tag + "");
-				
-		switch(encryptionDetail) {
+		Type encryptionDetailType = encryptionDetail.getEncryptionDetailType();
+				
+		switch(encryptionDetailType) {
 		case UnencryptedOnSave:
 			writeTagUnencryptedOnSave(toWrite, param, tags, tag);
@@ -166,7 +182,8 @@
 	}
 	
-	private void writeItemData(Frame frame) throws IOException {
+	private void writeItemData(Frame frame, boolean primaryItems) throws IOException {
 		// write each item in the frame
-		for (Item i : frame.getItemsToSave()) {
+		BodyType bodyType = primaryItems ? BodyType.PrimaryBody : BodyType.SurrogateBody;
+		for (Item i : frame.getItemsToSave(bodyType)) {
 			assert (!(i instanceof Line));
 			writeItem(i);
@@ -176,14 +193,4 @@
 			assert (!(i instanceof Line));
 			writeItem(i);
-		}
-		
-		// write out the surrogates
-		List<Item> surrogates = frame.getSurrogateItemsToSave();
-		if (!surrogates.isEmpty()) {
-			writeSurrogateTerminator();
-			for (Item i: surrogates) {
-				assert (!(i instanceof Line));
-				writeItem(i);
-			}
 		}
 	}
@@ -194,11 +201,14 @@
 		BinaryOperator<Boolean> trueExists = (a, b) -> a || b;
 		boolean surrogatesInherit = surrogateItems.stream().map(isTagInherited).collect(Collectors.reducing(trueExists)).get();
-		if (surrogatesInherit && 
-				Label.resolveKey(toWrite.getEncryptionLabel()) == LabelResult.SuccessResolveLabelToKey) {
-			toWrite.setEncryptionDetailForTag(tag + "", EncryptionDetail.UnencryptedOnSave);
+		boolean userHasKey = Label.getLabel(toWrite.getEncryptionLabel()) == LabelResult.SuccessResolveLabelToKey;
+		
+		if (!surrogatesInherit && userHasKey) {
+			EncryptionDetail reencryptOnSave = new EncryptionDetail(EncryptionDetail.Type.ReencryptOnSave);
+			toWrite.setEncryptionDetailForTag(tag + "", reencryptOnSave);
+			writeTagReencryptOnSave(toWrite, tags, tag);
+		} else {
+			EncryptionDetail unencryptedOnSave = new EncryptionDetail(EncryptionDetail.Type.UnencryptedOnSave);
+			toWrite.setEncryptionDetailForTag(tag + "", unencryptedOnSave);
 			writeTagUnencryptedOnSave(toWrite, new Object[] {}, tags, tag);
-		} else {
-			toWrite.setEncryptionDetailForTag(tag + "", EncryptionDetail.ReencryptOnSave);
-			writeTagReencryptOnSave(toWrite, tags, tag);
 		}
 	}
@@ -207,5 +217,5 @@
 		Method toRun = tags.get(tag);
 		Class<?> declarer = toRun.getDeclaringClass();
-		LabelResult res = Label.resolveKey(toWrite.getEncryptionLabel());
+		LabelResult res = Label.getLabel(toWrite.getEncryptionLabel());
 		if (declarer.isAssignableFrom(toWrite.getClass()) && res == LabelResult.SuccessResolveLabelToKey) {
 			try {
